﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Threading;

// Ilustrerer problemerne omkring tråde og synkronisering er løst med lock på objekt mens fælles data bruges
// Denne udgave er bedre ved brug af privat objekt som lås

namespace Trådeksempel5_Sync
{
    class Ex5Tråd_Bedre
    {
        private int trådCount = 0;
        private int count = 0;
        private char tegn;
        private int tal;
        private object read_update_lock = new object();

        public Ex5Tråd_Bedre(char tegn, int count)
        {
            this.count = count;
            this.tegn = tegn;
        }
        public void RunTråd()
        {
            char wtegn;             // må nu defineres uden for lock
            lock (read_update_lock) // sikre udelelighed af kritisk region
            {
                // ------------------------------------------------
                // Her kan komme synkroniseringsproblem - dog ikke så ofte
                // da det kun er meget lidt kode der kan afbrydes i
                int frem = trådCount;
                wtegn = (char)(((int)tegn) + frem);      // tegn ændres ved flere 
                // tråde på samme object
                trådCount++;
                // ------------------------------------------------
            }

            Random random = new Random();

            for (int gange = 0; gange < count; gange++)
            {
                System.Console.Write(wtegn);
                for (int x = 0; x < 20000000; x++) ;       // lav en forsinkelse aktiv

                lock (read_update_lock) // sikre udelelighed af kritisk region
                {
                    //--------------------------------------------------------
                    // Her kan forekomme synkroniserings problemer
                    // pausen fremprovokerer for tydeligheden
                    tal = tal + 1;                                          // synkroniserings problem skabes
                    Thread.Sleep(random.Next(1, 20));        // lav en forsinkelse pasiv
                    tal = tal - 1;
                    wtegn = (char)(((int)wtegn) + tal);       // da tal skulle være 0
                    // skulle wtegn ikke ændres
                    //--------------------------------------------------------
                }
            }
        }
    }
}
